import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class ControlCanvas extends ScaleCanvas implements MouseListener {
    Manager M;
    SelectInteger[] I=new SelectInteger[5];
    SelectColor SC;
    ListenSquare[] COL=new ListenSquare[30];
    ListenSquare CENTER,FIT,EDGE,CLEAR,AUTO;
    String VALUE;

    public ControlCanvas addManager(Manager M) {
	ControlCanvas Q=this;
	Q.M=M;
	return(Q);

    }

     public ControlCanvas() {
	 addMouseListener(this);
	 I[0]=new SelectInteger(5,5,40,20,1,1,5000,1);   //rows
	 I[1]=new SelectInteger(5,107,45,20,2,2,30,1);
	 I[2]=new SelectInteger(105,110,45,20,0,0,1,1);  //single congruence
	 I[3]=new SelectInteger(105,5,40,20,0,0,7,1);   //row step size
	 SC=new SelectColor(M,0,170,480,60);
	 FIT=new ListenSquare(300,10,60,20,Color.white);
	 FIT.on=1;
	 EDGE=new ListenSquare(380,10,20,20,Color.white);
	 EDGE.on=1;
	 AUTO=new ListenSquare(380,40,20,20,Color.white);
	 AUTO.on=1;
         CLEAR=new ListenSquare(300,40,60,20,Color.white);
	 CLEAR.on=1;
	 setColorSquares();
	 setColors();
	 VALUE="";
     }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(new Color(100,155,255));
      g.fillRect(0,0,getWidth(),getHeight());
      drawControls(g);
      SC.render(g);
      drawColorSquares(g);
      g.setColor(Color.black);  
      g.setFont(new Font("Helvetica",Font.PLAIN,16));
      g.drawString(VALUE,5,210);
   }


    public void setColorSquares() {

	for(int i=0;i<30;++i) {
            COL[i]=new ListenSquare(10+17*i,150,14,14,Color.white);
	    COL[i].on=1;
	}
    }

    public void setColors() {
	for(int i=0;i<30;++i) COL[i].C=Color.white;
	COL[I[2].val].C=new Color(255,255,150);
    }

    public void drawColorSquares(Graphics2D g) {
	for(int i=0;i<I[1].val;++i) {
            COL[i].render(g,COL[i].C);
	    Integer II=new Integer(i);
	    g.setColor(Color.black);
            g.setFont(new Font("Helvetica",Font.PLAIN,12));
	    g.drawString(II.toString(),13+17*i,145);
	    g.drawString("highlight single congruence",100,105);
	}
    }

    public void assignColors(Point X) {
	for(int i=0;i<30;++i) {
	    if(COL[i].inside(X)==1) COL[i].C=SC.C;
	}
    }



    public void drawControls(Graphics2D g) {

	for(int i=0;i<3;++i) {
           I[i].render(g,Color.white,Color.black,Color.black);
	}   
        I[3].render2(g,Color.white,Color.black,Color.black);
	g.setColor(Color.black);
        g.setFont(new Font("Helvetica",Font.PLAIN,16));
	g.drawString("# rows",10,45);
	g.drawString("row skip",100,45);
	g.drawString("mod",10,105);
	FIT.render(g,Color.white);
	EDGE.render(g,Color.white);
	CLEAR.render(g,Color.white);
	AUTO.render(g,Color.white);
	g.setColor(Color.black);  
        g.setFont(new Font("Helvetica",Font.PLAIN,16));
	g.drawString("fit",306,25);	
        g.drawString("edges",406,25);	
        g.drawString("auto fit",406,55);
	g.drawString("clear",306,55);

    }

    public void doClear() {
	I[0].val=1;
	M.P.doFit();
    }

    public void changeRowNumber(Point X) {
        I[3].modify(X);
	int n=I[3].val;
	n=(int)(Math.pow(2,n));
	I[0].step=n;
	I[0].modify(X); 
	I[1].modify(X);
        I[2].max=I[1].val;
        I[2].modifyCyclic(X);  
        if(I[2].isModified(X)==1) setColors();
    }


    public void mouseClicked(MouseEvent e) {
       MouseData J=MouseData.process(e);
       changeRowNumber(J.X);
       SC.process(e);
       assignColors(J.X);
       if(FIT.inside(J.X)==1) M.P.doFit();
       if(EDGE.inside(J.X)==1) EDGE.on=1-EDGE.on;
       if(AUTO.inside(J.X)==1) AUTO.on=1-AUTO.on;
       if(CLEAR.inside(J.X)==1) doClear();
       if(AUTO.on==1) M.P.doFit();
       M.P.setBoxes();
       VALUE="";
       repaint();
       M.P.repaint();  
    }


    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   




}

