import java.math.*;

public class PascalMath {

    public PascalMath() {}




    public static BigInteger factorial(int n) {
	BigInteger B1=new BigInteger("1");
	for(int i=2;i<=n;++i) {
	    Integer II=new Integer(i);
	    BigInteger B2=new BigInteger(II.toString());
	    B1=B1.multiply(B2);
	}
	return(B1);
    }

    public static BigInteger choose(int n,int k) {
	BigInteger B1=factorial(n);
	BigInteger B2=factorial(k);
	BigInteger B3=factorial(n-k);
	B1=B1.divide(B2);
	B1=B1.divide(B3);
	return(B1);
    }


    public static double normalizedChoose(int n,int k) {
	BigInteger B1=choose(n,k);
	BigInteger B2=choose(n,n/2);
	BigDecimal D1=new BigDecimal(B1.toString());
	BigDecimal D2=new BigDecimal(B2.toString());
	D1=D1.divide(D2,100,BigDecimal.ROUND_FLOOR);
	return(D1.doubleValue());
    }

    public static int findCutoff(int n,double d) {
	double test=0;
	for(int i=0;i<n;++i) {
	    test=normalizedChoose(n,i);
	    if(test>d) return(i);
	}
	return(-1);
    }

}

    







